<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<!--
Project:
  glideinWMS

File Version: 
  $Id: factoryCompletedStats.html,v 1.15 2011/04/08 21:42:08 amccrea Exp $

Description:
  Browse the glideinWMS RRDs

  Based on
  javascriptrrd/src/lib/rrdJFlot.html 
   Original repository: http://javascriptrrd.sourceforge.net/
-->

<html>
  
    <script type="text/javascript" src="jslibs/binaryXHR.js"></script>
    <script type="text/javascript" src="jslibs/rrdFile.js"></script>
    <script type="text/javascript" src="jslibs/rrdMultiFile.js"></script>
    <script type="text/javascript" src="jslibs/rrdFilter.js"></script>

    <!-- rrdFlot class needs the following four include files !-->
    <script type="text/javascript" src="jslibs/rrdFlotSupport.js"></script>
    <script type="text/javascript" src="jslibs/rrdFlot.js"></script>
    <script type="text/javascript" src="jslibs/jquery.js"></script>
    <script type="text/javascript" src="jslibs/jquery.flot.js"></script>
    <script type="text/javascript" src="jslibs/jquery.flot.selection.js"></script>

    <script type="text/javascript" src="jslibs/factory_support.js"></script>
  <head>
    <title>Completed glidein factory stats</title>
  </head>

  <body>
    <table width="100%">
    <tr>
     <td><h1 id="title">Glidein factory status from logs</h1>
     <td align="right">
      <SELECT id="destination" style="float:right" onChange="goToDestination(this)" >
<OPTION VALUE="" >Choose a Glidein destination...</OPTION>
<OPTION VALUE="factoryEntryStatusNow.html"> Glidein entry. </OPTION>
<OPTION VALUE="factoryStatusNow.html"> Glidein factory status now. </OPTION>
<OPTION VALUE="factoryStatus.html"> Glidein factory status. </OPTION>
<OPTION VALUE="factoryLogStatus.html"> Glidein factory log status. </OPTION>
<OPTION VALUE="factoryRRDBrowse.html"> Glidein factory browse.</OPTION>
<OPTION VALUE="factoryRRDEntryMatrix.html"> Glidein factory entry matrix. </OPTION>
</SELECT>
    </tr>
    </table>

    <table border=0>
     <tr>
       <th>Entry</th>
       <td valing="middle">
         <select id="entries">
	  <option value="total">total</option>
	 </select>
       </td>
     </tr>
     <tr>
       <th>Info group</th>
       <td valign="middle"><form id="gtypes">
	<input type="radio" name="gtype" value="Lasted">Wallclock time per glidein
	<input type="radio" name="gtype" value="JobsNr">User jobs per glidein
	<input type="radio" name="gtype" value="JobsLasted">Wallclock time per user job
	      <br>
	<input type="radio" name="gtype" value="validation">Fraction wasted due to node validation
	<input type="radio" name="gtype" value="idle">Fraction wasted because idle
	      <br>
	<input type="radio" name="gtype" value="nosuccess">Fraction wasted due to job failures
	<input type="radio" name="gtype" value="badput" checked>Fraction not used by user jobs
       </form></td>
     </tr>
     <tr>
      <td colspan=2><button onClick="fname_update()">Update</button><button onClick="showLink()" style="float:right">Link</button></td>
     </tr>
    </table>

    <hr>

    <table id="infotable" border=1>
        <tr><td colspan="21"><b>Javascript needed for this page to work</b></td></tr>
	<tr><td><b>RRD file</b></td><td id="fname" colspan="5">None</td></tr>
    </table>

    <div id="mygraph"></div>

   <hr>
    <p>Powered by
        <a href="http://oss.oetiker.ch/rrdtool/" target="_blank">RRDTool</a>,
        <a href="https://sourceforge.net/projects/javascriptrrd/" target="_blank">JavascriptRRD</a> and                                                              
        <a href="http://code.google.com/p/flot/" target="_blank">Flot</a>.

     <script type="text/javascript">

      var a =  document.getElementById("gtypes"); 
	  var infoGroupOptions = new Array("Lasted", "JobsNr", "JobsLasted", "validation", "idle", "nosuccess", "badput");
	  var ENTRY; 

      // Remove the Javascript warning
      document.getElementById("infotable").deleteRow(0);

      // Load the status of the factory
      var factoryQStats=loadFactoryQStats();
      //var entries=getFactoryEntries(factoryQStats);

      var entries=getFactoryEntryGroups(factoryQStats);
      group_map = entries;
      char_count=0;
      groups_starting_idx = 0;
      var entries_processed = 0;

      var ordered_entries_groups = [];
      for(entry in entries) {
          var e = (entries[entry]).toString();
          if (((e.split(",")).length == 1) && (e == entry.toString())){
              ordered_entries_groups[entry] = entries[entry];
              groups_starting_idx++;
          }
      }
      for(entry in entries) {
          var e = (entries[entry]).toString();
          if (((e.split(",")).length > 1) || (e != entry.toString())){
              ordered_entries_groups[entry] = entries[entry];
          }
      }
      entries = ordered_entries_groups;

      var entries_select=document.getElementById("entries");
      var sep1 = new Option("--------------------","-");
      var sep2 = new Option("--------------------","-");
      sep1.disabled = true;
      sep2.disabled = true;
      entries_select.appendChild(sep1);
      var ec_added = 0;
      for (var entry in entries) {
          if (ec_added < groups_starting_idx) {
              entries_select.appendChild(new Option(entries[entry],entries[entry]));
              ec_added++;
          } else {
              if ((ec_added == groups_starting_idx) && (ec_added != 0)){ 
                  entries_select.appendChild(sep2);
              }
              entries_select.appendChild(new Option(entry,entries[entry]));
              ec_added++;
          } 
      }

     // fname, gtype_id and rrd_data are the global variable used by all the functions below
      rrd_data=undefined;
      gtype_id=undefined;
      rrd_group_data=[];
      files_loaded = 0;
	  checkUrl(); 

      function DoNothing(ds) {
        this.getName = function() {return ds;}
        this.getDSNames = function() {return [ds];}
        this.computeResult = function(val_list) {return val_list[0];}
      }

      function SumDS(ds1,ds2) {
        this.getName = function() {return ds1+"+"+ds2;}
        this.getDSNames = function() {return [ds1,ds2];}
        this.computeResult = function(val_list) {return val_list[0]+val_list[1];}
      }

      function MultiSumDS(list) {

        // scaled by amount given by DS name
        // example: "Lasted_5m" multiplied by 5

        var i = 0;
        var name_list=[];
        for(i=0;i<list.length;i++){
           name_list.push(list[i].getName());
        }
        
        this.getName = function() { return "WeightedSum"; }
        this.getDSNames = function() {
           return name_list;}
        this.computeResult = function(val_list) {
           var val_sum=0;
           var i=0;
           for(i=0;i<val_list.length;i++){
              value = scale(name_list[i],val_list[i]);
              val_sum+=value;
           }
           return val_sum;
        }
      }

      function scale(name, value) {
         if (name.search(/Lasted/)>=0) { //if name contains 'Lasted' or 'JobsLasted'
            word = name.replace(/Lasted_/,""); 
            if (name.search(/Jobs/)>0) {word = word.replace(/Jobs/,"");} 
            if (/Unknown/.test(word)) {multiplier = 0;}
            else if (/Minutes/.test(word)) {multiplier = 7.5;}
            else if (/30mins/.test(word)) {multiplier = 30;}
            else if (/2hours/.test(word)) {multiplier = 120;}
            else if (/8hours/.test(word)) {multiplier = 480;}
            else if (/32hours/.test(word)) {multiplier = 1920;}
            else if (/Days/.test(word)) {multiplier = 7680;}
         }
         else if (name.search(/JobsNr/)>=0) { //if name contains 'JobsNr'
            word = name.replace(/JobsNr_/,""); 
            if (/None/.test(word)) {multiplier = 0;}
            else if (/1job/.test(word)) {multiplier = 1;}
            else if (/2jobs/.test(word)) {multiplier = 2;}
            else if (/4jobs/.test(word)) {multiplier = 4;}
            else if (/16jobs/.test(word)) {multiplier = 16;}
            else if (/Many/.test(word)) {multiplier = 64;}
         }
         else if (name.search(/validation/)>=0 || name.search(/idle/)>=0
                  || name.search(/nosuccess/)>=0 || name.search(/badput/)>=0) { 
            word = name.replace(/validation_/,""); 
            word = name.replace(/idle_/,""); 
            word = name.replace(/nosuccess_/,""); 
            word = name.replace(/badput_/,""); 
            if (/All/.test(word)) {multiplier = 1000;}
            else if (/Most/.test(word)) {multiplier = 750;} //approximate
            else if (/500m/.test(word)) {multiplier = 500;} 
            else if (/250m/.test(word)) {multiplier = 250;} 
            else if (/100m/.test(word)) {multiplier = 100;} 
            else if (/25m/.test(word)) {multiplier = 25;} 
            else if (/5m/.test(word)) {multiplier = 5;} 
            else if (/None/.test(word)) {multiplier = 0;} 
         }
         return value*multiplier;
      }
    
      function entrylist2groupname(elist) {
          var gname = elist;
          for(var g in group_map) {
              if ((group_map[g] == elist) && (g.toString() != elist)){
                  gname = g;
                  break;
              }
          }
          return gname;
      }


      // This function updates the Web Page with the data from the RRD archive header
      // when a new file is selected
      function update_plot() {
        var lengthGTypes=['Lasted','JobsLasted'];
        var lengths=['Unknown','Minutes','30mins','2hours','8hours','32hours','Days'];
        var lengths_colors=['000000',   // Unknown
                            'ff8000',   // Minutes
                            'ffff00',   // 30 mins
                            '00c000',   // 2 hours
                            '00ff00',   // 8 hours
                            '0000ff',   // 32 hours
                            'ff00ff'];  // Days

        var jobGTypes=['JobsNr'];
        var jobs=['None','1job','2jobs','4jobs','16jobs','Many'];
        var jobs_colors=['ff0000',   // None
                         'ffff00',   // 1 job
                         '00ffff',   // 2 jobs
                         '00ff00',   // 4 jobs
                         '0000ff',   // 16 jobs
                         'ff00ff'];  // Many

        var fracGTypes=['validation','idle','nosuccess','badput'];
        var fracs=['All','Most','500m','250m','100m','25m','5m','None'];
        var fracs_colors=['c00000',   // All
                          'ff2000',   // Most
                          'ffd000',   // 500m
                          'ffff00',   // 250m
                          'd0ff00',   // 100m
                          '40ff00',   // 25m
                          '00e000',   // 5m
                          '008000'];  // None


        // Piece together elements, such as Lasted_Unknown
        //    and JobsNr_4jobs

        var gtype_DSs=new Object();
        for (var lg in lengthGTypes) {
          var lg_name=lengthGTypes[lg];
          gtype_DSs[lg_name]=new Array();
          for (var len in lengths) {
            gtype_DSs[lg_name].push(lg_name+'_'+lengths[len]);
          }
        }
        for (var jb in jobGTypes) {
          var jb_name=jobGTypes[jb];
          gtype_DSs[jb_name]=new Array();
          for (var cnt in jobs) {
            gtype_DSs[jb_name].push(jb_name+'_'+jobs[cnt]);
          }
        }
        for (var fc in fracGTypes) {
          var fc_name=fracGTypes[fc];
          gtype_DSs[fc_name]=new Array();
          for (var cnt in fracs) {
            gtype_DSs[fc_name].push(fc_name+'_'+fracs[cnt]);
          }
        }

        var gtype_formats=new Object();

        // apply colors

        for (var lg in lengthGTypes) {
          var lg_name=lengthGTypes[lg];
          gtype_formats[lg_name]={};
          for (var len in lengths) {
            gtype_formats[lg_name][lg_name+'_'+lengths[len]]={label:lengths[len],stack:'positive',checked:(len!=0),
                    color:"#"+lengths_colors[len],lines: {show:true, fill:true,fillColor:"#"+lengths_colors[len]}};
          }
        }
        for (var jb in jobGTypes) {
          var jb_name=jobGTypes[jb];
          gtype_formats[jb_name]={};
          for (var cnt in jobs) {
            gtype_formats[jb_name][jb_name+'_'+jobs[cnt]]={label:jobs[cnt],stack:'positive',checked:true,
                color:"#"+jobs_colors[cnt],lines: {show:true, fill:true,fillColor:"#"+jobs_colors[cnt]}};
          }
        }
        for (var fc in fracGTypes) {
          var fc_name=fracGTypes[fc];
          gtype_formats[fc_name]={};
          for (var cnt in fracs) {
            gtype_formats[fc_name][fc_name+'_'+fracs[cnt]]={label:fracs[cnt],stack:'positive',checked:true,
                color:"#"+fracs_colors[cnt],lines: {show:true, fill:true,fillColor:"#"+fracs_colors[cnt]}};
          }
        }

        // chosen attributes ('Lasted_Unknown') fitered from all RRD data


        var rrd_data1 = undefined;
        if (rrd_group_data.length == 0) {
            rrd_data1=new RRDFilterDS(rrd_data,gtype_DSs[gtype_id]);
        } else {
              var rrd_data_sum = new RRDFileSum(rrd_group_data, false);
              rrd_data1=new RRDFilterDS(rrd_data_sum,gtype_DSs[gtype_id]);
        }

        //create a new rrdlist, which contains all original elements 
        //    plus an element which is a sum of the first two
        var op_list = [];
        var DS_list = [];
        var i = 0;
        for (i=0;i<rrd_data1.getNrDSs();i++) { 
           op_list.push(new DoNothing(rrd_data1.getDS(i).getName()));
           DS_list.push(rrd_data1.getDS(i));
        } 
        op_list.push(new MultiSumDS(DS_list));
            
        rrd_data1 = new RRDFilterOp(rrd_data1,op_list);

        // the rrdFlot object creates and handles the graph
        var f=new rrdFlot("mygraph",rrd_data1,null,gtype_formats[gtype_id]);

        // Finally, update the files loaded so far
        files_loaded = files_loaded + 1;
        var total_file_to_load = fname.split(",").length
        if (files_loaded < total_file_to_load) {
            document.getElementById("fname").firstChild.data="Loaded files " + files_loaded + "/" + total_file_to_load;
        }
        else {
            document.getElementById("fname").firstChild.data="Loaded files " + files_loaded + "/" + total_file_to_load + ": " + fname;
        }

      }

      // This is the callback function that,
      // given a binary file object,
      // verifies that it is a valid RRD archive
      // and performs the update of the Web page
      function update_plot_handler(bf) {
          var i_rrd_data=undefined;
          try {
            var i_rrd_data=new RRDFile(bf);            
          } catch(err) {
            alert("File "+fname+" is not a valid RRD archive!");
          }
          if (i_rrd_data!=undefined) {
            rrd_data=i_rrd_data;
            update_plot()
          }
      }

      function update_grouped_plot_handler(bf) {
          var i_rrd_data=undefined;
          var idx = 0;
          if (rrd_group_data != undefined) {
            idx = rrd_group_data.length;
          } else {
            rrd_group_data = [];
          }

          try {
            var i_rrd_data=new RRDFile(bf);            
          } catch(err) {
            alert("File "+fname+" is not a valid RRD archive!");
          }
          if (i_rrd_data!=undefined) {
            rrd_group_data[idx] = new Array(); 
            rrd_group_data[idx] = i_rrd_data;
            update_plot()
          }
      }

      // this function is invoked when the RRD file name changes
      function fname_update() {
        var entry_name="";
        gtype_id=undefined;
        rrd_group_data=[];
        rrd_data=undefined;
        files_loaded = 0;

        var entries_obj=document.getElementById("entries");
        entry_name=entries_obj.options[entries_obj.selectedIndex].value;

        var gtypes_obj=document.getElementById("gtypes");
        for (var i in gtypes_obj.gtype) {
         var gtype=gtypes_obj.gtype[i];
         if (gtype.checked==true) {
  	   gtype_id=gtype.value;
         }
        }

        if ((gtype_id=='Lasted')  || (gtype_id=='JobsLasted')|| (gtype_id=='JobsNr')) {
          rrd_fname="Log_Completed_Stats";
        } else if ((gtype_id=='validation')  || (gtype_id=='idle')|| (gtype_id=='nosuccess') || (gtype_id=='badput')) {
          rrd_fname="Log_Completed_WasteTime";
        } else {
          alert("Unknown gtype_id "+gtype_id); // should never enter here
          rrd_fname=none;
        }

        if (entry_name=="total") {
          fname="total/"+rrd_fname+".rrd";
        } else {
          fname="entry_"+entry_name+"/total/"+rrd_fname+".rrd";
        }

        if ( (entry_name == "total") || (((entry_name.split(",")).length == 1) && (entry_name == entrylist2groupname(entry_name.split(",")))) ){
          //document.getElementById("fname").firstChild.data="Loading "+fname;
          document.getElementById("fname").firstChild.data="Loaded files " + files_loaded + "/" + fname.split(",").length;
          try {
            FetchBinaryURLAsync(fname,update_plot_handler);
          } catch (err) {
             alert("Failed loading "+fname+"\n"+err);
          }
        } else {
          var en_array = entry_name.split(",");
          fname = "";
          for (var i=0; i<en_array.length; i++) {
              if (i == 0) {
                  fname="entry_"+en_array[i]+"/total/"+rrd_fname+".rrd";
              } else {
                  fname=fname+",entry_"+en_array[i]+"/total/"+rrd_fname+".rrd";
              }
          }
          //document.getElementById("fname").firstChild.data="Loading " + fname;
          document.getElementById("fname").firstChild.data="Loaded files " + files_loaded + "/" + fname.split(",").length;

          for (var i=0; i<en_array.length; i++) {
            var fn = "entry_"+en_array[i]+"/total/"+rrd_fname+".rrd"; 
            try {
              FetchBinaryURLAsync(fn,update_grouped_plot_handler);
            } catch (err) {
               alert("Failed loading "+fn+"\n"+err);
            }
          }
        }
      }
	/* Function to read from the url any parameters the user has specified. */
	function checkUrl()
	{
		var url = window.location.search;
		parameterArry = new Array("entry", "infoGroup"); 
		groups = new Array("CMST1", "CMS", "CMST2", "US", "CMST3", "HCC");
		group = 0;  
		var entrySpec; 
		var infoGroupSpec;
		urlValid = 0; 
		paramSpecArry = new Array(); 
		if(url)
		{
			url = url.substring(1);
			urlSplit = url.split('&'); 
			i = 0; 
			while(i < urlSplit.length)
			{ 
				equalSplit = urlSplit[i].split('='); 
				if(equalSplit[0] == parameterArry[i])
				{
					paramSpecArry[i] = equalSplit[1];
				}
				i++; 
			}
		}
		for(i = 0; i< paramSpecArry.length; i++)
		{
			counter = 2; 
			if(i == 0)
			{
				for(entry in entries)
				{
					if(entry == paramSpecArry[0])
					{
						ENTRY = paramSpecArry[0]; 
						urlValid = 1; 
						for(j = 0; j< groups.length; j++)
						{
							if(entry == groups[j])
							{
								document.getElementById("entries").selectedIndex = counter + 1; 
								group = 1;
								break;  
							}	
						}
						if(!group)
						{
							document.getElementById("entries").selectedIndex = counter; 
						}
						break;
					} 
					else if("total" == 	paramSpecArry[0])
					{
						urlValid = 1; 
						document.getElementById("entries").selectedIndex = 0; 
						break;  	
					}
					counter++; 
				}
			}
			else if(i == 1)
			{
				child = 1; 
				for(i = 0; i< infoGroupOptions.length; i++)
				{
					if(infoGroupOptions[i] == paramSpecArry[1])
					{
						document.getElementById("gtypes").elements[i].checked = true;
						urlValid = 1; 
					}
					child+=2;	
				}
			}
		}
		if(urlValid)
		{
			fname_update();
		}
	}
	/* Function to show link for current options. */
	function showLink()
	{
		constructed = document.URL.split('?');
		entriesTable = document.getElementById("entries"); 
		var specifiedEntry;
		var specifiedGOption; 
		/* Find the current entry specified. */
		for(i = 0; i < entriesTable.options.length; i++)
		{
			if(entriesTable.options[i].selected == true)
			{
				specifiedEntry = entriesTable.options[i].text; 	
			}
		}
		gOptionTable = document.getElementById("gtypes");
		j = 0;  
		/* Find the current group option specified. */
		for(i = 1; i< gOptionTable.childNodes.length; i+=2)
		{
			if(gOptionTable.childNodes[i].checked == true)
			{
				specifiedGOption = infoGroupOptions[j];
			}
			if(gOptionTable.childNodes[i].value)
			{
				j++;
			}
		}
		constructed = constructed[0] + "?entry=" + specifiedEntry + "&infoGroup=" + specifiedGOption; 
		document.location.href = constructed; 
	}  
	/* Function to navigate to other glidein tools. */
	function goToDestination(option)
	{
		if(option.value != "factoryStatusNow.html" && option.value != "factoryRRDEntryMatrix.html" && ENTRY)
		{
			document.location.href = option.value + "?entry=" + ENTRY; 
		}
		else
		{
			document.location.href = option.value; 
		}
		document.getElementById("destination").selectedIndex = 0; 
	}
    </script>
  </body>
</html>
